% 1)
geneNames = importdata('geneNames.txt'); % Measured genes
load data
X = data.exprs; % the genes expressions
y = data.classes; % the samples labels:
% '2' ... AML
% '1' ... ALL

% learning the tree on complete data
tree = fitctree(X,y); 
%%
% 2)

view(tree, 'mode','graph')
% and its TRAINING accuracy
mean(y==predict(tree, X))

%%
% 3)  Estimation of real accuracy of the tree by the means of crossvalidation
cv = cvpartition(length(y),'kfold',10);

PA = []; % predictive accuracy
for i = 1:10
    trI = cv.training(i);
    tstI = cv.test(i);
    
    % tree learning
    % ...
    
    % tree testing
    pa = % accuracy in THIS fold
    
    PA = [PA; pa];
end
mean(PA)

%%
% % % % % % % % % % % % % % % % % % %
% Analyzing the data in terms of PCA

% 1)  
% learning principal components of the data
V = pca(X);

componentNumbers = [...] % range of component numbers

% 2) - 3)
PAs = []; % predictive accuracies of trees based on subsequent decompositions
for K = componentNumbers

    % transforming the data into top K components
    Z = X*V(1:K,:)';
    
    % Here learn a tree on Z
    % ...

    % show it and enumearate its TRAINING accuracy
    % ...
    PA = % training accuracy of the tree learned on top K data components
    
    PAs = [PAs; PA];

end
%%
% 4) 
% For the optimal K_opt, heuristically chosen according to the criteria
% above...

K_opt = % optimal number of copmponents

% Make an optimal data transformation
Z_opt = X*V(1:K_opt,:)';

% And estimate the real accuracy of emerging tree-model by the means of 
% crossvalidation

PA = [];
for i = 1:10
    trI = cv.training(i);
    tstI = cv.test(i);
           
    % learning principal components of TRAINING data
    % ...
    
    % transformation of TRAINING data into first K_opt of the principal components
    % ...
    
    % learning a tree on the transformed data
    % ...
    
    % transformation of TESTING data
    % ...
    
    % testing the tree on the transformed data
    % ...
    pa = % accuracy in THIS fold
    
    PA = [PA; pa];
end
mean(PA)

%%
% % % % % % % % % % % % % % 
% Interpreting the results

% indices of the top components in your tree
componentIndices = [% indices of the top components in your tree
		      ];

compGenes = cell(length(componentIndices), 1); % genes active in the top components in your tree
% extracting the genes active in the components
for i = 1:length(componentIndices)
    comp = componentIndices(i);
    compGenes{i} =mineGenes(V(comp,:), geneNames);
end

